const path = require('path');
const fs = require('fs');
const { promisify } = require('util');
const ejs = require('ejs');

function handleCreatePath(dirPath) {
  if (fs.existsSync(dirPath)) {
    return true;
  } else {
    if (handleCreatePath(path.dirname(dirPath))) {
      //如果有当前路径就创建文件夹
      fs.mkdirSync(dirPath);
      return true;
    }
  }
}
/**
 *
 * @param {*} targetPath 目标文件夹，需要包含文件后缀名
 * @param {*} file 文件
 */
async function handleWriteFile(targetPath, file) {
  try {
    await promisify(fs.writeFile)(targetPath, file);
    console.log('恭喜，文件写入成功！');
  } catch (err) {
    console.log('写入文件失败！', err);
  }
}

//解析ejs模板为文件
/**
 *
 * @param {*} path 文件路径字符串
 * @param {*} data 模板选项
 * @param {*} options ejs参数
 * @returns
 */
async function renderEjs(path, data, options) {
  return new Promise((resolve, reject) => {
    ejs.renderFile(path, data, options, function (err, str) {
      if (err) {
        reject(err);
      } else {
        resolve(str);
      }
    });
  });
}

module.exports = {
  handleCreatePath,
  handleWriteFile,
  renderEjs,
};
