const { program } = require('commander');
const { handleWriteFile, renderEjs, handleCreatePath } = require('../hooks');
const path = require('path');
const { toLine } = require('../../../utils');
const mkcnpAction = async (fileName, cmd) => {
  //解析ejs模板，传入相应参数，写入到对应文件夹里面
  const ejsPath = path.resolve(
    __dirname,
    '../../../ejsTemplate/vue3cnp.vue.ejs',
  );
  const file = await renderEjs(
    ejsPath,
    { cnpName: fileName, className: toLine(fileName) },
    {},
  );
  const targetPath = cmd.dir
    ? path.resolve(process.cwd(), cmd.dir)
    : process.cwd();
  handleCreatePath(targetPath + `/${fileName}`);
  handleWriteFile(targetPath + `/${fileName}/index.vue`, file);
};

program
  .command('mkcnp <fileName>')
  .option('-d,--dir [value]', 'targetDir')
  .description('make a vue3 template')
  .action(mkcnpAction);
